import { Client, ClientChannel, ConnectConfig } from 'ssh2';
import { SSHForward } from './SSHForward';
export interface IConnectConfigHop extends ConnectConfig {
    through?: IConnectConfigHop | SSHClient;
    host: string;
    port: number;
    tunnels?: Array<{
        remotePort: number;
        remoteHost: string;
        localPort: number;
    }>;
}
export declare class SSHClient extends Client {
    private _tunnels;
    private _parent?;
    private _childs;
    private _justHop;
    constructor();
    connect(config: IConnectConfigHop): void;
    releaseParent(): false | SSHClient;
    forwardPort(localPort: number, remoteAdress: string, remotePort: number): SSHForward;
    forwardSocket(dstIP: string, dstPort: number, onConnection: (err: Error | undefined, channel: ClientChannel) => void): void;
    getPortForwards(): Array<SSHForward>;
    private _connectThrough;
    private _internalOnClose;
}
